/***************************************************************************
                          klogoturtle.cpp  -  description
                             -------------------
    begin                : Sb Nov  1 18:43:53 BRT 2003
    copyright            : (C) 2003 by Euclides Lourenco Chuma
    email                : euclideschuma@yahoo.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qobject.h>
#include <qfile.h>
#include <qstring.h>
#include <qpainter.h>
#include <qprinter.h>


// include files for KDE
#include <kaccel.h>
#include <kaction.h>
#include <kapplication.h>
#include <kcombobox.h>
#include <kconfig.h>
#include <kdebug.h>
#include <kfiledialog.h>
#include <khelpmenu.h>
#include <kiconloader.h>
#include <kkeydialog.h>
#include <klocale.h>
#include <kmenubar.h>
#include <kmessagebox.h>
#include <kstatusbar.h>
#include <kstdaccel.h>
#include <kstdaction.h>
#include <kstandarddirs.h>
#include <ktoolbar.h>

// application specific includes
#include "klogoturtle.h"

//That's for the StatusBar
//If you define more, it will allow you to have several items in the StatusBar
const int ID_STATUS_MSG     = 1;

KlogoturtleApp::KlogoturtleApp(QWidget* , const char* name):KMainWindow(0, name)
{
    config=kapp->config();

    idioma_escolhido = "ingles";

    ///////////////////////////////////////////////////////////////////
    // call inits to invoke all other construction parts
    initView();
    initActions();

    statusBar( )->insertItem("   ",ID_STATUS_MSG, 0);
    //you can insert more items here to print more stuff in the statusbar
    statusBar()->show();
    slotStatusMsg(i18n("Ready."), ID_STATUS_MSG);
    //Tool Bar
    toolBar()->enableMoving( false );

    readOptions();

    setSizePolicy (QSizePolicy::Fixed, QSizePolicy::Fixed, TRUE);
    setFixedSize (800, 580);
    apaga_to();
    n_to = 0;
    qual_comando = 1;
    QPixmap::setDefaultOptimization(QPixmap::BestOptim);

    setCentralWidget(des);

    setAutoSaveSettings();
}

KlogoturtleApp::~KlogoturtleApp()
{}

void KlogoturtleApp::initActions()
{
    KStdAction::openNew(this, SLOT(slotFileNew()), actionCollection());
    KStdAction::open(this, SLOT(slotFileOpen()), actionCollection());
    KStdAction::save(this, SLOT(slotFileSave()), actionCollection());
    KStdAction::saveAs(this, SLOT(slotFileSaveAs()), actionCollection());
    KStdAction::print(this, SLOT(slotFilePrint()), actionCollection());
    KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection());
    KStdAction::cut(ComandoTextEdit, SLOT(cut()), actionCollection());
    KStdAction::copy(ComandoTextEdit, SLOT(copy()), actionCollection());
    KStdAction::paste(ComandoTextEdit, SLOT(paste()), actionCollection());
    saveImage = new KAction(i18n("Save &Image..."), 0, this, SLOT(slotSaveImage()), actionCollection(), "save_image");
    // disable actions at startup
    actionCollection()->action("file_save")->setEnabled(false);
    actionCollection()->action("file_save_as")->setEnabled(false);
    actionCollection()->action("save_image")->setEnabled(false);
    actionCollection()->action("file_print")->setEnabled(false);
    actionCollection()->action("edit_cut")->setEnabled(false);
    actionCollection()->action("edit_copy")->setEnabled(false);
    actionCollection()->action("edit_paste")->setEnabled(false);
    // Settings menu

#if KDE_IS_VERSION( 3, 1, 90 )
    createStandardStatusBarAction();
    setStandardToolBarMenuEnabled(true);
#endif
    KStdAction::keyBindings(this, SLOT(optionsConfigureKeys()), actionCollection());

    // Language menu
    englishAction = new KToggleAction(i18n("English"), 0, this, SLOT(slotIngles()), actionCollection(), "lang_english");
    portugueseAction = new KToggleAction(i18n("Portuguese"), 0, this, SLOT(slotPortugues()), actionCollection(), "lang_portuguese");
    germanAction = new KToggleAction(i18n("German"), 0, this, SLOT(slotAlemao()), actionCollection(), "lang_german");
    italianAction = new KToggleAction(i18n("Italian"), 0, this, SLOT(slotItaliano()), actionCollection(), "lang_italian");
    frenchAction = new KToggleAction(i18n("French"), 0, this, SLOT(slotFrances()), actionCollection(), "lang_french");

    createGUI("klogoturtleui.rc");
}

///In Settings menu, Configure Shortcuts... menu item
void KlogoturtleApp::optionsConfigureKeys()
{
    KKeyDialog::configureKeys(actionCollection(), "klogoturtleui.rc");
}

void KlogoturtleApp::initView()
{
    ////////////////////////////////////////////////////////////////////
    // create the main widget here that is managed by KTMainWindow's view-region and
   // connect the widget to your document to display document contents.

    des = new Desenho(this);
    des->move(5,60);
    des->setFixedSize(590,400);
    des->setFrameStyle(QFrame::Panel | QFrame::Sunken);
    des->show();

    label1 = new QLabel(this, "label1");
    label1->setText(i18n("Commands:"));
    label1->setGeometry(610,60,120,20);

    label2 = new QLabel(this, "label2");
    label2->setText(i18n("Messages:"));
    label2->setGeometry(610,460,120,20);

    ComandoTextEdit = new KTextEdit(this, "ComandoTextEdit");
    ComandoTextEdit->setGeometry(610,80,180,315);
    ComandoTextEdit->setTextFormat(QTextEdit::PlainText);
    ComandoTextEdit->setWordWrap(QTextEdit::NoWrap);
    QObject::connect(ComandoTextEdit, SIGNAL(textChanged ()), this, SLOT(slotEnableActions()));
    MensagemTextEdit = new KTextEdit(this, "MensagemTextEdit");
    MensagemTextEdit->setGeometry(610,480,180,75);
    MensagemTextEdit->setReadOnly(true);

    runButton  = new KPushButton(this, "runButton ");
    runButton->setText(i18n("&Run"));
    runButton->setGeometry(710,410,80,30);
    QObject::connect(runButton, SIGNAL(clicked()), this, SLOT(slotRun()));

    label3 = new QLabel(this, "label3");
    QPixmap *pixmapl = new QPixmap();
    pixmapl->load(locate("data","klogoturtle/turtle.png"));
    label3->setPixmap(*pixmapl);
    label3->setGeometry(210,470,160,80);
}


void KlogoturtleApp::saveOptions()
{
    config->setGroup("General Options");
    config->writeEntry("Geometry", size());
    config->writeEntry("ToolBarPos", (int) toolBar("mainToolBar")->barPos());

    if (idioma_escolhido == "ingles") config->writeEntry("Idioma", 1);
    if (idioma_escolhido == "portugues") config->writeEntry("Idioma", 2);
    if (idioma_escolhido == "alemao") config->writeEntry("Idioma", 3);
    if (idioma_escolhido == "italiano") config->writeEntry("Idioma", 4);
    if (idioma_escolhido == "frances") config->writeEntry("Idioma", 5);
}


void KlogoturtleApp::readOptions()
{

    config->setGroup("General Options");

    //Language configure
    int idioma_temp = config->readNumEntry("Idioma", true);

    if(idioma_temp == 1)
    {
        englishAction->setChecked(true);
        idioma_escolhido = "ingles";
    }
    else
    {
        if(idioma_temp == 2)
        {
                portugueseAction->setChecked(true);
                idioma_escolhido = "portugues";
        }
        else
        {
                if(idioma_temp == 3)
                {
                    germanAction->setChecked(true);
                    idioma_escolhido = "alemao";
                }
                else
                {
                    if(idioma_temp == 4)
                    {
                      italianAction->setChecked(true);
                      idioma_escolhido = "italiano";
                    }
                    else
                    {
                      if(idioma_temp == 5)
                      {
                        frenchAction->setChecked(true);
                        idioma_escolhido = "frances";
                      }
                      else
                      {
                        englishAction->setChecked(true);
                        idioma_escolhido = "ingles";
                      }
                    }
                }
        }

    }

    // bar position settings
    KToolBar::BarPosition toolBarPos;
    toolBarPos=(KToolBar::BarPosition) config->readNumEntry("ToolBarPos", KToolBar::Top);
    toolBar("mainToolBar")->setBarPos(toolBarPos);

    QSize size=config->readSizeEntry("Geometry");
    if(!size.isEmpty())
    {
        resize(size);
    }

}


bool KlogoturtleApp::queryExit()
{
    saveOptions();
    return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////


void KlogoturtleApp::slotFileNew()
{
    slotStatusMsg(i18n("Creating new document..."), ID_STATUS_MSG);
    ComandoTextEdit->setText("");
    filename = "";
    des->cnew();
    slotStatusMsg(i18n("Ready."), ID_STATUS_MSG);
}

void KlogoturtleApp::slotFileOpen()
{
    slotStatusMsg(i18n("Opening file..."), ID_STATUS_MSG);

    QString fn = QFileDialog::getOpenFileName(QString::null, QString::null,this);
    if (!fn.isEmpty())
    {
        QFile f(fn);
        if (!f.open(IO_ReadOnly))
            return;
        QTextStream ts(&f);
        ComandoTextEdit->setText(ts.read());
        slotStatusMsg(i18n("Loaded document."), ID_STATUS_MSG);
        filename = fn;
    }
    else
        slotStatusMsg(i18n("Loading aborted."), ID_STATUS_MSG);

    slotStatusMsg(i18n("Ready."),ID_STATUS_MSG);
}


void KlogoturtleApp::slotFileSave()
{
    slotStatusMsg(i18n("Saving file..."),ID_STATUS_MSG);

    if (filename.isEmpty())
    {
        slotFileSaveAs();
        return;
    }

    QString text = ComandoTextEdit->text();
    QFile f(filename);
    if (!f.open(IO_WriteOnly))
    {
        slotStatusMsg(i18n("Could not write to file."),ID_STATUS_MSG);
        return;
    }

    QTextStream t(&f);
    t << text;
    f.close();

    slotStatusMsg(i18n("File saved."), ID_STATUS_MSG);
    slotStatusMsg(i18n("Ready."),ID_STATUS_MSG );
}

void KlogoturtleApp::slotFileSaveAs()
{
    slotStatusMsg(i18n("Saving file with a new filename..."), ID_STATUS_MSG);

    QString fn = QFileDialog::getSaveFileName(QString::null, QString::null, this);
    if (!fn.isEmpty())
    {
        filename = fn;
        slotFileSave();
    }
    else
    {
        slotStatusMsg(i18n("Saving aborted"), ID_STATUS_MSG);
    }

    slotStatusMsg(i18n("Ready."), ID_STATUS_MSG);
}



void KlogoturtleApp::slotFilePrint()
{
    slotStatusMsg(i18n("Printing..."),ID_STATUS_MSG);

    const int Margin = 10;
    QPrinter printer;

    if (printer.setup(this))
    {
        QPainter printpainter(&printer);

        printpainter.setFont(ComandoTextEdit->font());
        int yPos = 0;                               // y-position for each line
        QFontMetrics fm = printpainter.fontMetrics();
        QPaintDeviceMetrics metrics(printpainter.device());       // need width/height of printer surface
        for(int i = 0 ; i < ComandoTextEdit->lines() ; i++)
        {
            if (Margin + yPos > metrics.height() - Margin)
            {
                printer.newPage();                 // no more room on this page
                yPos = 0;                           // back to top of page
            }
            printpainter.drawText(Margin, Margin + yPos, metrics.width(), fm.lineSpacing(), ExpandTabs | DontClip, ComandoTextEdit->text(i));
            yPos = yPos + fm.lineSpacing();
        }

        printpainter.end();
        slotStatusMsg(i18n("Printing completed."), ID_STATUS_MSG);
    }
    else
    {
        slotStatusMsg(i18n("Printing aborted."), ID_STATUS_MSG);
    }

    slotStatusMsg(i18n("Ready."), ID_STATUS_MSG);
}


void KlogoturtleApp::slotFileQuit()
{
    slotStatusMsg(i18n("Exiting..."), ID_STATUS_MSG);
    saveOptions();
    close();
}

///Nice method for updating the statusBar when several items
void KlogoturtleApp::slotStatusMsg(const QString& text, int id)
{
    // display the text on the statusbar
    statusBar()->changeItem(text, id);
}

void KlogoturtleApp::slotSaveImage()
{
    QString fni = QFileDialog::getSaveFileName(QString::null, "*.png", this);
    if (!fni.isEmpty())
    {
        filename = fni;
        des->salva_imagem(filename, "PNG");
    }
    else
    {
        slotStatusMsg(i18n("Saving aborted"), ID_STATUS_MSG);
    }

}


void KlogoturtleApp::slotIngles()
{
    englishAction->setChecked(true);
    portugueseAction->setChecked(false);
    germanAction->setChecked(false);
    italianAction->setChecked(false);
    frenchAction->setChecked(false);
    idioma_escolhido = "ingles";
}


void KlogoturtleApp::slotAlemao()
{
    englishAction->setChecked(false);
    portugueseAction->setChecked(false);
    germanAction->setChecked(true);
    italianAction->setChecked(false);
    frenchAction->setChecked(false);
    idioma_escolhido = "alemao";
}


void KlogoturtleApp::slotItaliano()
{
    englishAction->setChecked(false);
    portugueseAction->setChecked(false);
    germanAction->setChecked(false);
    italianAction->setChecked(true);
    frenchAction->setChecked(false);
    idioma_escolhido = "italiano";
}

void KlogoturtleApp::slotFrances()
{
    englishAction->setChecked(false);
    portugueseAction->setChecked(false);
    germanAction->setChecked(false);
    italianAction->setChecked(false);
    frenchAction->setChecked(true);
    idioma_escolhido = "frances";
}


void KlogoturtleApp::slotPortugues()
{
    englishAction->setChecked(false);
    portugueseAction->setChecked(true);
    germanAction->setChecked(false);
    italianAction->setChecked(false);
    frenchAction->setChecked(false);
    idioma_escolhido = "portugues";
}


int KlogoturtleApp::Exe_comando(int pos_comando)
{
    QString comando;
    QString parametro_s;
    QString var_nome;
    QString var_int;
    int prox_comando;
    int ini_repete;
    int tamanho;
    int espacos;
    int parametro;
    int parametro_rep;
    int existe_comando;
    bool ok;
    bool okt;
    bool okt_rep;
    bool okt_des;

    existe_comando = -1;
    prox_comando = pos_comando + 1;


    if(qual_comando == 1)
    {
        comando = ((ComandoTextEdit->text(pos_comando)).upper()).simplifyWhiteSpace();
    }
    else
    {
        comando = (temp_comando_to.section('#', pos_comando, pos_comando).upper()).simplifyWhiteSpace();
    }

    espacos = comando.contains(' ',FALSE);

    if(espacos > 0)
    {
        for(int i = 0; i <= espacos; i++)
        {
            comando.remove(comando.find(' ',0),1);
        }
    }


    //Commands in english
    if(idioma_escolhido == "ingles")
    {
       if(comando.startsWith("FORWARD")) comando.replace("FORWARD","FD");
       if(comando.startsWith("BACKWARD")) comando.replace("BACKWARD","BK");
       if(comando.startsWith("RIGHT")) comando.replace("RIGHT","RT");
       if(comando.startsWith("LEFT")) comando.replace("LEFT","LT");
       if(comando.startsWith("SETX")) comando.replace("SETX","SX");
       if(comando.startsWith("SETY")) comando.replace("SETY","SY");
       if(comando.startsWith("PENDOWN")) comando.replace("PENDOWN","PD");
       if(comando.startsWith("PENUP")) comando.replace("PENUP","PU");
       if(comando.startsWith("CLEAR")) comando.replace("CLEAR","CS");
       if(comando.startsWith("HOME")) comando.replace("HOME","HM");
       if(comando.startsWith("HIDETURTLE")) comando.replace("HIDETURTLE","HT");
       if(comando.startsWith("SHOWTURTLE")) comando.replace("SHOWTURTLE","ST");
       if(comando.startsWith("PENCOLOR")) comando.replace("PENCOLOR","PC");
       if(comando.startsWith("SUM")) comando.replace("SUM","ADD");
       if(comando.startsWith("SUBTRACT")) comando.replace("SUBTRACT","SUB");
       if(comando.startsWith("MULTIPLY")) comando.replace("MULTIPLY","MUL");
       if(comando.startsWith("DIVIDE")) comando.replace("DIVIDE","DIV");
       if(comando.startsWith("REMAINDER")) comando.replace("REMAINDER","REM");
    }


    //Commands in portuguese
    if(idioma_escolhido == "portugues")
    {
       if(comando.startsWith("FRENTE")) comando.replace("FRENTE","FD");
       if(comando.startsWith("ATRAS")) comando.replace("ATRAS","BK");
       if(comando.startsWith("DIREITA")) comando.replace("DIREITA","RT");
       if(comando.startsWith("ESQUERDA")) comando.replace("ESQUERDA","LT");
       if(comando.startsWith("MUDAX")) comando.replace("MUDAX","SX");
       if(comando.startsWith("X")) comando.replace("X","SX");
       if(comando.startsWith("MUDAY")) comando.replace("MUDAY","SY");
       if(comando.startsWith("Y")) comando.replace("Y","SY");
       if(comando.startsWith("DESCELAPIS")) comando.replace("DESCELAPIS","PD");
       if(comando.startsWith("DESCE")) comando.replace("DESCE","PD");
       if(comando.startsWith("SOBELAPIS")) comando.replace("SOBELAPIS","PU");
       if(comando.startsWith("SOBE")) comando.replace("SOBE","PU");
       if(comando.startsWith("LIMPA")) comando.replace("LIMPA","CS");
       if(comando.startsWith("CENTRO")) comando.replace("CENTRO","HM");
       if(comando.startsWith("ESCONDE")) comando.replace("ESCONDE","HT");
       if(comando.startsWith("MOSTRA")) comando.replace("MOSTRA","ST");
       if(comando.startsWith("COR")) comando.replace("COR","PC");
       if(comando.startsWith("ADICAO")) comando.replace("ADICAO","ADD");
       if(comando.startsWith("SOMA")) comando.replace("SOMA","ADD");
       if(comando.startsWith("SUBTRACAO")) comando.replace("SUBTRACAO","SUB");
       if(comando.startsWith("SUBTRAI")) comando.replace("SUBTRAI","SUB");
       if(comando.startsWith("MULTIPLICACAO")) comando.replace("MULTIPLICACAO","MUL");
       if(comando.startsWith("MULTIPLICA")) comando.replace("MULTIPLICA","MUL");
       if(comando.startsWith("DIVISAO")) comando.replace("DIVISAO","DIV");
       if(comando.startsWith("DIVIDE")) comando.replace("DIVIDE","DIV");
       if(comando.startsWith("RESTO")) comando.replace("RESTO","REM");
       if(comando.startsWith("SE")) comando.replace("SE","IF");
       if(comando.startsWith("FIMSE")) comando.replace("FIMSE","ENDIF");
       if(comando.startsWith("REPETE")) comando.replace("REPETE","REPEAT");
       if(comando.startsWith("FIMREPETE")) comando.replace("FIMREPETE","ENDREPEAT");
       if(comando.startsWith("DEFINE")) comando.replace("DEFINE","TO");
       if(comando.startsWith("FIMDEFINE")) comando.replace("FIMDEFINE","ENDTO");
       if(comando.startsWith("FACA")) comando.replace("FACA","MAKE");
       if(comando.startsWith("CONTEUDO")) comando.replace("CONTEUDO","SHOW");
       if(comando.startsWith("NOVO")) comando.replace("NOVO","NEW");
    }


    if(idioma_escolhido == "alemao")
    {
       if(comando.startsWith("VORWAERTS")) comando.replace("VORWAERTS","FD");
       if(comando.startsWith("ZURUECK")) comando.replace("ZURUECK","BK");
       if(comando.startsWith("RECHTS")) comando.replace("RECHTS","RT");
       if(comando.startsWith("LINKS")) comando.replace("LINKS","LT");
       if(comando.startsWith("SETZEX")) comando.replace("SETZEX","SX");
       if(comando.startsWith("SETZEY")) comando.replace("SETZEY","SY");
       if(comando.startsWith("ABSETZEN")) comando.replace("ABSETZEN","PD");
       if(comando.startsWith("ANHEBEN")) comando.replace("ANHEBEN","PU");
       if(comando.startsWith("LOESCHEN")) comando.replace("LOESCHEN","CS");
       if(comando.startsWith("MITTE")) comando.replace("MITTE","HM");
       if(comando.startsWith("VERSTECKE")) comando.replace("VERSTECKE","HT");
       if(comando.startsWith("ZEIGE")) comando.replace("ZEIGE","ST");
       if(comando.startsWith("FARBE")) comando.replace("FARBE","PC");
       if(comando.startsWith("ADDIERE")) comando.replace("ADDIERE","ADD");
       if(comando.startsWith("SUBTRAHIERE")) comando.replace("SUBTRAHIERE","SUB");
       if(comando.startsWith("MULTIPLIZIERE")) comando.replace("MULTIPLIZIERE","MUL");
       if(comando.startsWith("DIVIDIERE")) comando.replace("DIVIDIERE","DIV");
       if(comando.startsWith("REST")) comando.replace("REST","REM");
       if(comando.startsWith("WENN")) comando.replace("WENN","IF");
       if(comando.startsWith("ENDEWENN")) comando.replace("ENDEWENN","ENDIF");
       if(comando.startsWith("WIEDERHOLE")) comando.replace("WIEDERHOLE","REPEAT");
       if(comando.startsWith("ENDEWIEDERHOLE")) comando.replace("ENDEWIEDERHOLE","ENDREPEAT");
       if(comando.startsWith("ZU")) comando.replace("ZU","TO");
       if(comando.startsWith("ENDEZU")) comando.replace("ENDEZU","ENDTO");
       if(comando.startsWith("SETZE")) comando.replace("SETZE","MAKE");
       if(comando.startsWith("INHALT")) comando.replace("INHALT","SHOW");
       if(comando.startsWith("NEU")) comando.replace("NEU","NEW");
    }

    if(idioma_escolhido == "italiano")
    {
       if(comando.startsWith("AVANTI")) comando.replace("AVANTI","FD");
       if(comando.startsWith("INDIETRO")) comando.replace("INDIETRO","BK");
       if(comando.startsWith("DESTRA")) comando.replace("DESTRA","RT");
       if(comando.startsWith("SINISTRA")) comando.replace("SINISTRA","LT");
       if(comando.startsWith("ASSEX")) comando.replace("ASSEX","SX");
       if(comando.startsWith("ASSEY")) comando.replace("ASSEY","SY");
       if(comando.startsWith("SCRIVI")) comando.replace("SCRIVI","PD");
       if(comando.startsWith("NONSCRIVERE")) comando.replace("NONSCRIVERE","PU");
       if(comando.startsWith("PULISCI")) comando.replace("PULISCI","CS");
       if(comando.startsWith("CENTRA")) comando.replace("CENTRA","HM");
       if(comando.startsWith("NASCONDI")) comando.replace("NASCONDI","HT");
       if(comando.startsWith("MOSTRA")) comando.replace("MOSTRA","ST");
       if(comando.startsWith("COLORE")) comando.replace("COLORE","PC");
       if(comando.startsWith("SOMMA")) comando.replace("SOMMA","ADD");
       if(comando.startsWith("SOTTRAI")) comando.replace("SOTTRAI","SUB");
       if(comando.startsWith("MOLTIPLICA")) comando.replace("MOLTIPLICA","MUL");
       if(comando.startsWith("DIVIDI")) comando.replace("DIVIDI","DIV");
       if(comando.startsWith("RESTO")) comando.replace("RESTO","REM");
       if(comando.startsWith("NUOVO")) comando.replace("NUOVO","NEW");
       if(comando.startsWith("SE")) comando.replace("SE","IF");
       if(comando.startsWith("FINESE")) comando.replace("FINESE","ENDIF");
       if(comando.startsWith("RIPETI")) comando.replace("RIPETI","REPEAT");
       if(comando.startsWith("FINERIPETI")) comando.replace("FINERIPETI","ENDREPEAT");
       if(comando.startsWith("IN")) comando.replace("IN","TO");
       if(comando.startsWith("FINEIN")) comando.replace("FINEIN","ENDTO");
       if(comando.startsWith("CREA")) comando.replace("CREA","MAKE");
       if(comando.startsWith("CONTENUTO")) comando.replace("CONTENUTO","SHOW");
    }

    if(idioma_escolhido == "frances")
    {
       if(comando.startsWith("AVANCE")) comando.replace("AVANCE","FD");
       if(comando.startsWith("RECULE")) comando.replace("RECULE","BK");
       if(comando.startsWith("DROITE")) comando.replace("DROITE","RT");
       if(comando.startsWith("GAUCHE")) comando.replace("GAUCHE","LT");
       if(comando.startsWith("POSX")) comando.replace("POSX","SX");
       if(comando.startsWith("POSY")) comando.replace("POSY","SY");
       if(comando.startsWith("BAISSECRAYON")) comando.replace("BAISSECRAYON","PD");
       if(comando.startsWith("LEVECRAYON")) comando.replace("LEVECRAYON","PU");
       if(comando.startsWith("VIDECRAN")) comando.replace("VIDECRAN","CS");
       if(comando.startsWith("ORIGINE")) comando.replace("ORIGINE","HM");
       if(comando.startsWith("CACHETORTUE")) comando.replace("CACHETORTUE","HT");
       if(comando.startsWith("MONTRETORTUE")) comando.replace("MONTRETORTUE","ST");
       if(comando.startsWith("CHANGECOULEUR")) comando.replace("CHANGECOULEUR","PC");
       if(comando.startsWith("SOMME")) comando.replace("SOMME","ADD");
       if(comando.startsWith("DIFFERENCE")) comando.replace("DIFFERENCE","SUB");
       if(comando.startsWith("PRODUIT")) comando.replace("PRODUIT","MUL");
       if(comando.startsWith("QUOTIENT")) comando.replace("QUOTIENT","DIV");
       if(comando.startsWith("RESTE")) comando.replace("RESTE","REM");
       if(comando.startsWith("NOUVEAU")) comando.replace("NOUVEAU","NEW");
       if(comando.startsWith("SI")) comando.replace("SI","IF");
       if(comando.startsWith("FINSI")) comando.replace("FINSI","ENDIF");
       if(comando.startsWith("REPETE")) comando.replace("REPETE","REPEAT");
       if(comando.startsWith("FINREPETE")) comando.replace("FINREPETE","ENDREPEAT");
       if(comando.startsWith("POUR")) comando.replace("POUR","TO");
       if(comando.startsWith("FINPOUR")) comando.replace("FINPOUR","ENDTO");
       if(comando.startsWith("CREE")) comando.replace("CREE","MAKE");
       if(comando.startsWith("VALEUR")) comando.replace("VALEUR","SHOW");
    }



    if(comando != "")
    {

        if(comando.startsWith("REPEAT"))
        {
            ini_repete = pos_comando + 1;
            tamanho = comando.length();
            parametro_rep = (comando.mid(6,tamanho)).toInt(&okt,10);

            QString texto_temp = ((ComandoTextEdit->text()).upper()).simplifyWhiteSpace();
            int espacos_temp = texto_temp.contains(' ',FALSE);

            if(espacos_temp > 0)
            {
                for(int i = 0; i <= espacos_temp; i++)
                {
                    texto_temp.remove(texto_temp.find(' ',0),1);
                }
            }

            if(texto_temp.contains("FIMREPETE",false)) comando.replace("FIMREPETE","ENDREPEAT");

            int n_endrepeat = texto_temp.contains("ENDREPEAT", false);
            int n_repeat = (texto_temp.contains("REPEAT", false)) - n_endrepeat;

            if (n_repeat == n_endrepeat)
            {
                if(okt)
                {
                    prox_comando =  Repete(parametro_rep, ini_repete);
                    existe_comando = 1;
                }
                else
                {
                    parametro_rep = (des->show_var(comando.mid(6,tamanho))).toInt(&okt_rep,10);
                    if(okt_rep)
                    {
                        prox_comando =  Repete(parametro_rep, ini_repete);
                        existe_comando = 1;
                    }
                    else
                    {
                        MensagemTextEdit->append(i18n("REPEAT with invalid argument"));
                        stop_error();
                    }
                }
            }
            else
            {
                MensagemTextEdit->append(i18n("REPEAT without END REPEAT"));
                stop_error();
            }

        }
        else
        {
            if(comando.startsWith("ENDREPEAT"))
            {
                prox_comando = -1;
                pos_end_repete = pos_comando + 1;
                existe_comando = 1;

            }
            else
            {
                if(comando.startsWith("MAKE"))
                {
                    bool ok_make_temp;
                    bool ok_make_temp2;

                    prox_comando = pos_comando + 1;
                    tamanho = comando.length();

                    int pos_igual = comando.find('=',0);

                    if(pos_igual != -1)
                    {
                        int temp_make;
                        int temp_make2;
                        var_nome = (comando.mid(4,(pos_igual-4)));
                        var_int = (comando.mid(pos_igual+1,tamanho-(pos_igual+1)));
                        temp_make = var_int.toInt(&ok_make_temp,10);
                        temp_make2 = var_nome.toInt(&ok_make_temp2,10);
                        if(ok_make_temp2)
                        {
                            MensagemTextEdit->append(i18n("Variable of MAKE is not correct"));
                            stop_error();
                        }
                        else
                        {
                            if(ok_make_temp)
                            {
                                des->make(var_nome.upper(),var_int);
                                existe_comando = 1;
                            }
                            else
                            {
                                MensagemTextEdit->append(i18n("Argument of MAKE is not number"));
                                stop_error();
                            }
                        }
                    }
                    else
                    {
                        MensagemTextEdit->append(i18n("MAKE without ="));
                        stop_error();
                    }
                }
                else
                {
                    if(comando.startsWith("PC"))
                    {
                        prox_comando = pos_comando + 1;
                        tamanho = comando.length();
                        parametro_s = (comando.mid(2,tamanho));
                        des->pc(parametro_s);
                        existe_comando = 1;

                    }
                    else
                    {
                        if(comando.startsWith("SHOW"))
                        {
                            prox_comando = pos_comando + 1;
                            tamanho = comando.length();
                            parametro_s = (comando.mid(4,tamanho));
                            MensagemTextEdit->append(i18n(des->show_var(parametro_s)));
                            existe_comando = 1;
                        }
                        else
                        {
                            if(comando.startsWith("TO"))
                            {
                                int existe_endto = -1;

                                for(int y = pos_comando; y <= ComandoTextEdit->paragraphs(); y++)
                                {
                                    QString com_endto = ((ComandoTextEdit->text(y)).upper()).simplifyWhiteSpace();
                                    int esp_endto = com_endto.contains(' ',FALSE);
                                    if(esp_endto > 0)
                                    {
                                        for(int e = 0; e <= esp_endto; e++)
                                        {
                                            com_endto.remove(com_endto.find(' ',0),1);
                                        }
                                    }

                                    if(com_endto.startsWith("FIMDEFINE")) com_endto.replace("FIMDEFINE","ENDTO");

                                    if(com_endto.startsWith("ENDTO"))
                                    {
                                        existe_endto = y;
                                        break;
                                    }

                                }

                                if(existe_endto != -1)
                                {
                                    QString cop_to_temp;
                                    cop_to_temp = "";

                                    for(int rr = pos_comando; rr <= existe_endto; rr++)
                                    {
                                        cop_to_temp.append(ComandoTextEdit->text(rr));
                                        cop_to_temp.append("#");
                                    }

                                    int pos_pontos = comando.find(':',0);

                                    int pos_marca_nome;

                                    if(pos_pontos != -1)
                                    {
                                        pos_marca_nome  = pos_pontos;

                                        int qtd_pontos = comando.contains(':',false);
                                        for(int jj = 1; jj <= qtd_pontos; jj++)
                                        {
                                            if((comando.section(':',jj,jj)).length() < 4)
                                            {
                                                MensagemTextEdit->append(i18n("Command variable of TO have length less than 4"));
                                                stop_error();
                                                break;
                                            }
                                        }

                                    }
                                    else
                                    {
                                        pos_marca_nome = comando.length();
                                    }

                                    QString nome_to = comando.mid(2,(pos_marca_nome-2));
                                    int pos_to_temp = find_to(nome_to);

                                    if(pos_to_temp != -1)
                                    {
                                        guarda_to [pos_to_temp] [0] = nome_to.upper();
                                        guarda_to [pos_to_temp] [1] = cop_to_temp;
                                    }
                                    else
                                    {
                                        guarda_to [n_to] [0] = nome_to.upper();
                                        guarda_to [n_to] [1] = cop_to_temp;
                                        n_to = n_to + 1;
                                    }
                                    prox_comando = existe_endto + 1;
                                    existe_comando = 1;

                                }
                                else
                                {
                                    MensagemTextEdit->append(i18n("TO without END TO"));
                                    stop_error();
                                }

                            }
                            else
                            {
                                if (comando.startsWith("ADD") || comando.startsWith("SUB") || comando.startsWith("MUL") || comando.startsWith("DIV") || comando.startsWith("REM"))
                                {
                                    prox_comando = pos_comando + 1;

                                    if (comando.startsWith("ADD"))
                                    {
                                        QString var_recebe;
                                        QString var_param1;
                                        QString var_param2;
                                        int pos_ident = comando.find('=',0);
                                        int pos_sign = comando.find('+',0);
                                        if(pos_ident == -1 || pos_sign == -1)
                                        {
                                            MensagemTextEdit->append(i18n("Command ADD without = or +"));
                                            stop_error();
                                        }
                                        else
                                        {
                                            int taman_temp = comando.length();
                                            var_recebe = comando.mid(3,(pos_ident-3));
                                            var_param1 = comando.mid((pos_ident+1),(pos_sign-pos_ident-1));
                                            var_param2 = comando.mid((pos_sign+1),taman_temp-(pos_sign+1));
                                            bool ok_param2;
                                            int i_param2 = var_param2.toInt(&ok_param2, 10);
                                            if(ok_param2 != true)
                                            {
                                                QString param2_temp = des->show_var(var_param2);
                                                bool ok_param2_temp;
                                                i_param2 = param2_temp.toInt(&ok_param2_temp, 10);
                                                if(ok_param2_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of ADD is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_param1;
                                            int i_param1 = var_param1.toInt(&ok_param1, 10);
                                            if(ok_param1 != true)
                                            {
                                                QString param1_temp = des->show_var(var_param1);
                                                bool ok_param1_temp;
                                                i_param1 = param1_temp.toInt(&ok_param1_temp, 10);
                                                if(ok_param1_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of ADD is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_recebe;
                                            int recebe_ok_temp = var_recebe.toInt(&ok_recebe, 10);
                                            recebe_ok_temp = 0;
                                            if(ok_recebe == true)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of ADD is number"));
                                                stop_error();
                                            }
                                            else
                                            {
                                                des->make(var_recebe.upper(),QString::number((i_param1 + i_param2), 10));
                                            }
                                        }
                                    }

                                    if (comando.startsWith("SUB"))
                                    {
                                        QString var_recebe;
                                        QString var_param1;
                                        QString var_param2;
                                        int pos_ident = comando.find('=',0);
                                        int pos_sign = comando.find('-',0);
                                        if(pos_ident == -1 || pos_sign == -1)
                                        {
                                            MensagemTextEdit->append(i18n("Command SUB without = or -"));
                                            stop_error();
                                        }
                                        else
                                        {
                                            int taman_temp = comando.length();
                                            var_recebe = comando.mid(3,(pos_ident-3));
                                            var_param1 = comando.mid((pos_ident+1),(pos_sign-pos_ident-1));
                                            var_param2 = comando.mid((pos_sign+1),taman_temp-(pos_sign+1));
                                            bool ok_param2;
                                            int i_param2 = var_param2.toInt(&ok_param2, 10);
                                            if(ok_param2 != true)
                                            {
                                                QString param2_temp = des->show_var(var_param2);
                                                bool ok_param2_temp;
                                                i_param2 = param2_temp.toInt(&ok_param2_temp, 10);
                                                if(ok_param2_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of SUB is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_param1;
                                            int i_param1 = var_param1.toInt(&ok_param1, 10);
                                            if(ok_param1 != true)
                                            {
                                                QString param1_temp = des->show_var(var_param1);
                                                bool ok_param1_temp;
                                                i_param1 = param1_temp.toInt(&ok_param1_temp, 10);
                                                if(ok_param1_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of SUB is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_recebe;
                                            int recebe_ok_temp = var_recebe.toInt(&ok_recebe, 10);
                                            recebe_ok_temp = 0;
                                            if(ok_recebe == true)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of SUB is number"));
                                                stop_error();
                                            }
                                            else
                                            {
                                                des->make(var_recebe.upper(),QString::number((i_param1 - i_param2), 10));
                                            }
                                        }
                                    }


                                    if (comando.startsWith("MUL"))
                                    {
                                        QString var_recebe;
                                        QString var_param1;
                                        QString var_param2;
                                        int pos_ident = comando.find('=',0);
                                        int pos_sign = comando.find('*',0);
                                        if(pos_ident == -1 || pos_sign == -1)
                                        {
                                            MensagemTextEdit->append(i18n("Command MUL without = or *"));
                                            stop_error();
                                        }
                                        else
                                        {
                                            int taman_temp = comando.length();
                                            var_recebe = comando.mid(3,(pos_ident-3));
                                            var_param1 = comando.mid((pos_ident+1),(pos_sign-pos_ident-1));
                                            var_param2 = comando.mid((pos_sign+1),taman_temp-(pos_sign+1));
                                            bool ok_param2;
                                            int i_param2 = var_param2.toInt(&ok_param2, 10);
                                            if(ok_param2 != true)
                                            {
                                                QString param2_temp = des->show_var(var_param2);
                                                bool ok_param2_temp;
                                                i_param2 = param2_temp.toInt(&ok_param2_temp, 10);
                                                if(ok_param2_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of MUL is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_param1;
                                            int i_param1 = var_param1.toInt(&ok_param1, 10);
                                            if(ok_param1 != true)
                                            {
                                                QString param1_temp = des->show_var(var_param1);
                                                bool ok_param1_temp;
                                                i_param1 = param1_temp.toInt(&ok_param1_temp, 10);
                                                if(ok_param1_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of MUL is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_recebe;
                                            int recebe_ok_temp = var_recebe.toInt(&ok_recebe, 10);
                                            recebe_ok_temp = 0;
                                            if(ok_recebe == true)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of MUL is number"));
                                                stop_error();
                                            }
                                            else
                                            {
                                                des->make(var_recebe.upper(),QString::number((i_param1 * i_param2), 10));
                                            }
                                        }
                                    }


                                    if (comando.startsWith("DIV"))
                                    {
                                        QString var_recebe;
                                        QString var_param1;
                                        QString var_param2;
                                        int pos_ident = comando.find('=',0);
                                        int pos_sign = comando.find('/',0);
                                        if(pos_ident == -1 || pos_sign == -1)
                                        {
                                            MensagemTextEdit->append(i18n("Command DIV without = or /"));
                                            stop_error();
                                        }
                                        else
                                        {
                                            int taman_temp = comando.length();
                                            var_recebe = comando.mid(3,(pos_ident-3));
                                            var_param1 = comando.mid((pos_ident+1),(pos_sign-pos_ident-1));
                                            var_param2 = comando.mid((pos_sign+1),taman_temp-(pos_sign+1));
                                            bool ok_param2;
                                            int i_param2 = var_param2.toInt(&ok_param2, 10);
                                            if(ok_param2 != true)
                                            {
                                                QString param2_temp = des->show_var(var_param2);
                                                bool ok_param2_temp;
                                                i_param2 = param2_temp.toInt(&ok_param2_temp, 10);
                                                if(ok_param2_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of DIV is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            if (i_param2 <= 0)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of DIV is zero"));
                                                stop_error();
                                            }
                                            bool ok_param1;
                                            int i_param1 = var_param1.toInt(&ok_param1, 10);
                                            if(ok_param1 != true)
                                            {
                                                QString param1_temp = des->show_var(var_param1);
                                                bool ok_param1_temp;
                                                i_param1 = param1_temp.toInt(&ok_param1_temp, 10);
                                                if(ok_param1_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of DIV is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_recebe;
                                            int recebe_ok_temp = var_recebe.toInt(&ok_recebe, 10);
                                            recebe_ok_temp = 0;
                                            if(ok_recebe == true)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of DIV is number"));
                                                stop_error();
                                            }
                                            else
                                            {
                                                des->make(var_recebe.upper(),QString::number((i_param1 / i_param2), 10));
                                            }
                                        }
                                    }



                                    if (comando.startsWith("REM"))
                                    {
                                        QString var_recebe;
                                        QString var_param1;
                                        QString var_param2;
                                        int pos_ident = comando.find('=',0);
                                        int pos_sign = comando.find('/',0);
                                        if(pos_ident == -1 || pos_sign == -1)
                                        {
                                            MensagemTextEdit->append(i18n("Command REM without = or /"));
                                            stop_error();
                                        }
                                        else
                                        {
                                            int taman_temp = comando.length();
                                            var_recebe = comando.mid(3,(pos_ident-3));
                                            var_param1 = comando.mid((pos_ident+1),(pos_sign-pos_ident-1));
                                            var_param2 = comando.mid((pos_sign+1),taman_temp-(pos_sign+1));
                                            bool ok_param2;
                                            int i_param2 = var_param2.toInt(&ok_param2, 10);
                                            if(ok_param2 != true)
                                            {
                                                QString param2_temp = des->show_var(var_param2);
                                                bool ok_param2_temp;
                                                i_param2 = param2_temp.toInt(&ok_param2_temp, 10);
                                                if(ok_param2_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of REM is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            if (i_param2 <= 0)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of REM is zero"));
                                                stop_error();
                                            }
                                            bool ok_param1;
                                            int i_param1 = var_param1.toInt(&ok_param1, 10);
                                            if(ok_param1 != true)
                                            {
                                                QString param1_temp = des->show_var(var_param1);
                                                bool ok_param1_temp;
                                                i_param1 = param1_temp.toInt(&ok_param1_temp, 10);
                                                if(ok_param1_temp != true)
                                                {
                                                    MensagemTextEdit->append(i18n("Variable of REM is not number or not defined"));
                                                    stop_error();
                                                }
                                            }

                                            bool ok_recebe;
                                            int recebe_ok_temp = var_recebe.toInt(&ok_recebe, 10);
                                            recebe_ok_temp = 0;
                                            if(ok_recebe == true)
                                            {
                                                MensagemTextEdit->append(i18n("Variable of REM is number"));
                                                stop_error();
                                            }
                                            else
                                            {
                                                des->make(var_recebe.upper(),QString::number((i_param1 % i_param2), 10));
                                            }
                                        }
                                    }


                                    existe_comando = 1;
                                }
                                else
                                {

                                    //If command
                                    if(comando.startsWith("IF") || comando.startsWith("ENDIF"))
                                    {
                                        int existe_endif = -1;
                                        int taman_if_temp = comando.length();
                                        QString var_param1_if;
                                        QString var_param2_if;

                                        prox_comando = pos_comando + 1;

                                        for(int y = pos_comando; y <= ComandoTextEdit->paragraphs(); y++)
                                        {
                                            QString com_endif = ((ComandoTextEdit->text(y)).upper()).simplifyWhiteSpace();
                                            int esp_endif = com_endif.contains(' ',FALSE);
                                            if(esp_endif > 0)
                                            {
                                                for(int e = 0; e <= esp_endif; e++)
                                                {
                                                    com_endif.remove(com_endif.find(' ',0),1);
                                                }
                                            }

                                            if(com_endif.startsWith("FIMSE")) com_endif.replace("FIMSE","ENDIF");

                                            if(com_endif.startsWith("ENDIF"))
                                            {
                                                existe_endif = y;
                                                break;
                                            }

                                        }

                                        if(existe_endif != -1)
                                        {
                                            int pos_operando;
                                            pos_operando = comando.find("=", 0);
                                            if(pos_operando != -1)
                                            {
                                                var_param1_if = comando.mid(2,(pos_operando-2));
                                                var_param2_if = comando.mid((pos_operando+1),taman_if_temp-(pos_operando+1));

                                                bool ok_if_param1;
                                                int i_if_param1 = var_param1_if.toInt(&ok_if_param1, 10);
                                                if(ok_if_param1 != true)
                                                {
                                                    QString param1_if_temp = des->show_var(var_param1_if);
                                                    bool ok_param1_if_temp;
                                                    i_if_param1 = param1_if_temp.toInt(&ok_param1_if_temp, 10);
                                                    if(ok_param1_if_temp != true)
                                                    {
                                                        MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                        stop_error();
                                                    }
                                                }

                                                bool ok_if_param2;
                                                int i_if_param2 = var_param2_if.toInt(&ok_if_param2, 10);
                                                if(ok_if_param2 != true)
                                                {
                                                    QString param2_if_temp = des->show_var(var_param2_if);
                                                    bool ok_param2_if_temp;
                                                    i_if_param2 = param2_if_temp.toInt(&ok_param2_if_temp, 10);
                                                    if(ok_param2_if_temp != true)
                                                    {
                                                        MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                        stop_error();
                                                    }
                                                }

                                                if(i_if_param1 == i_if_param2)
                                                {
                                                    prox_comando = pos_comando + 1;
                                                }
                                                else
                                                {
                                                    prox_comando = existe_endif + 1;
                                                }
                                            }
                                            else
                                            {
                                                pos_operando = comando.find(">", 0);
                                                if(pos_operando != -1)
                                                {
                                                    var_param1_if = comando.mid(2,(pos_operando-2));
                                                    var_param2_if = comando.mid((pos_operando+1),taman_if_temp-(pos_operando+1));

                                                    bool ok_if_param1;
                                                    int i_if_param1 = var_param1_if.toInt(&ok_if_param1, 10);
                                                    if(ok_if_param1 != true)
                                                    {
                                                        QString param1_if_temp = des->show_var(var_param1_if);
                                                        bool ok_param1_if_temp;
                                                        i_if_param1 = param1_if_temp.toInt(&ok_param1_if_temp, 10);
                                                        if(ok_param1_if_temp != true)
                                                        {
                                                            MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                            stop_error();
                                                        }
                                                    }

                                                    bool ok_if_param2;
                                                    int i_if_param2 = var_param2_if.toInt(&ok_if_param2, 10);
                                                    if(ok_if_param2 != true)
                                                    {
                                                        QString param2_if_temp = des->show_var(var_param2_if);
                                                        bool ok_param2_if_temp;
                                                        i_if_param2 = param2_if_temp.toInt(&ok_param2_if_temp, 10);
                                                        if(ok_param2_if_temp != true)
                                                        {
                                                            MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                            stop_error();
                                                        }
                                                    }

                                                    if(i_if_param1 > i_if_param2)
                                                    {
                                                        prox_comando = pos_comando + 1;
                                                    }
                                                    else
                                                    {
                                                        prox_comando = existe_endif + 1;
                                                    }

                                                }
                                                else
                                                {
                                                    pos_operando = comando.find("<", 0);
                                                    if(pos_operando != -1)
                                                    {
                                                        var_param1_if = comando.mid(2,(pos_operando-2));
                                                        var_param2_if = comando.mid((pos_operando+1),taman_if_temp-(pos_operando+1));

                                                        bool ok_if_param1;
                                                        int i_if_param1 = var_param1_if.toInt(&ok_if_param1, 10);
                                                        if(ok_if_param1 != true)
                                                        {
                                                            QString param1_if_temp = des->show_var(var_param1_if);
                                                            bool ok_param1_if_temp;
                                                            i_if_param1 = param1_if_temp.toInt(&ok_param1_if_temp, 10);
                                                            if(ok_param1_if_temp != true)
                                                            {
                                                                MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                                stop_error();
                                                            }
                                                        }

                                                        bool ok_if_param2;
                                                        int i_if_param2 = var_param2_if.toInt(&ok_if_param2, 10);
                                                        if(ok_if_param2 != true)
                                                        {
                                                            QString param2_if_temp = des->show_var(var_param2_if);
                                                            bool ok_param2_if_temp;
                                                            i_if_param2 = param2_if_temp.toInt(&ok_param2_if_temp, 10);
                                                            if(ok_param2_if_temp != true)
                                                            {
                                                                MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                                stop_error();
                                                            }
                                                        }

                                                        if(i_if_param1 < i_if_param2)
                                                        {
                                                            prox_comando = pos_comando + 1;
                                                        }
                                                        else
                                                        {
                                                            prox_comando = existe_endif + 1;
                                                        }
                                                    }
                                                    else
                                                    {
                                                        pos_operando = comando.find("!", 0);
                                                        if(pos_operando != -1)
                                                        {
                                                            var_param1_if = comando.mid(2,(pos_operando-2));
                                                            var_param2_if = comando.mid((pos_operando+1),taman_if_temp-(pos_operando+1));

                                                            bool ok_if_param1;
                                                            int i_if_param1 = var_param1_if.toInt(&ok_if_param1, 10);
                                                            if(ok_if_param1 != true)
                                                            {
                                                                QString param1_if_temp = des->show_var(var_param1_if);
                                                                bool ok_param1_if_temp;
                                                                i_if_param1 = param1_if_temp.toInt(&ok_param1_if_temp, 10);
                                                                if(ok_param1_if_temp != true)
                                                                {
                                                                    MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                                    stop_error();
                                                                }
                                                            }

                                                            bool ok_if_param2;
                                                            int i_if_param2 = var_param2_if.toInt(&ok_if_param2, 10);
                                                            if(ok_if_param2 != true)
                                                            {
                                                                QString param2_if_temp = des->show_var(var_param2_if);
                                                                bool ok_param2_if_temp;
                                                                i_if_param2 = param2_if_temp.toInt(&ok_param2_if_temp, 10);
                                                                if(ok_param2_if_temp != true)
                                                                {
                                                                    MensagemTextEdit->append(i18n("Variable of IF is not number or not defined"));
                                                                    stop_error();
                                                                }
                                                            }

                                                            if(i_if_param1 != i_if_param2)
                                                            {
                                                                prox_comando = pos_comando + 1;
                                                            }
                                                            else
                                                            {
                                                                prox_comando = existe_endif + 1;
                                                            }
                                                        }
                                                        else
                                                        {
                                                            if(comando.startsWith("ENDIF") != true)
                                                            {
                                                                MensagemTextEdit->append(i18n("IF without operand"));
                                                                stop_error();
                                                            }
                                                        }
                                                    }

                                                }
                                            }

                                        }
                                        else
                                        {
                                            MensagemTextEdit->append(i18n("IF without END IF"));
                                            stop_error();
                                        }

                                        existe_comando = 1;

                                    }


                                    else
                                    {

                                        //Others commands

                                        prox_comando = pos_comando + 1;
                                        tamanho = comando.length();
                                        parametro = (comando.mid(2,tamanho)).toInt(&ok,10);
                                        if (comando.startsWith("FD"))
                                        {
                                            if (ok)
                                            {
                                                des->fd(parametro);
                                                existe_comando = 1;
                                            }
                                            else
                                            {
                                                parametro = (des->show_var(comando.mid(2,tamanho))).toInt(&okt_des,10);
                                                if(okt_des)
                                                {
                                                    des->fd(parametro);
                                                    existe_comando = 1;
                                                }
                                                else
                                                {
                                                    MensagemTextEdit->append(i18n("FD with invalid argument"));
                                                    stop_error();
                                                }
                                            }
                                        }

                                        if (comando.startsWith("BK"))
                                        {
                                            if (ok)
                                            {
                                                des->bk(parametro);
                                                existe_comando = 1;
                                            }
                                            else
                                            {
                                                parametro = (des->show_var(comando.mid(2,tamanho))).toInt(&okt_des,10);
                                                if(okt_des)
                                                {
                                                    des->bk(parametro);
                                                    existe_comando = 1;
                                                }
                                                else
                                                {
                                                    MensagemTextEdit->append(i18n("BK with invalid argument"));
                                                    stop_error();
                                                }
                                            }
                                        }

                                        if (comando.startsWith("LT"))
                                        {
                                            if (ok)
                                            {
                                                des->lt(parametro);
                                                existe_comando = 1;
                                            }
                                            else
                                            {
                                                parametro = (des->show_var(comando.mid(2,tamanho))).toInt(&okt_des,10);
                                                if(okt_des)
                                                {
                                                    des->lt(parametro);
                                                    existe_comando = 1;
                                                }
                                                else
                                                {
                                                    MensagemTextEdit->append(i18n("LT with invalid argument"));
                                                    stop_error();
                                                }
                                            }
                                        }

                                        if (comando.startsWith("RT"))
                                        {
                                            if (ok)
                                            {
                                                des->rt(parametro);
                                                existe_comando = 1;
                                            }
                                            else
                                            {
                                                parametro = (des->show_var(comando.mid(2,tamanho))).toInt(&okt_des,10);
                                                if(okt_des)
                                                {
                                                    des->rt(parametro);
                                                    existe_comando = 1;
                                                }
                                                else
                                                {
                                                    MensagemTextEdit->append(i18n("RT with invalid argument"));
                                                    stop_error();
                                                }
                                            }
                                        }

                                        if (comando.startsWith("SX"))
                                        {
                                            if (ok)
                                            {
                                                des->sx(parametro);
                                                existe_comando = 1;
                                            }
                                            else
                                            {
                                                parametro = (des->show_var(comando.mid(2,tamanho))).toInt(&okt_des,10);
                                                if(okt_des)
                                                {
                                                    des->sx(parametro);
                                                    existe_comando = 1;
                                                }
                                                else
                                                {
                                                    MensagemTextEdit->append(i18n("SX with invalid argument"));
                                                    stop_error();
                                                }
                                            }
                                        }

                                        if (comando.startsWith("SY"))
                                        {
                                            if (ok)
                                            {
                                                des->sy(parametro);
                                                existe_comando = 1;
                                            }
                                            else
                                            {
                                                parametro = (des->show_var(comando.mid(2,tamanho))).toInt(&okt_des,10);
                                                if(okt_des)
                                                {
                                                    des->sy(parametro);
                                                    existe_comando = 1;
                                                }
                                                else
                                                {
                                                    MensagemTextEdit->append(i18n("SY with invalid argument"));
                                                    stop_error();
                                                }
                                            }

                                        }



                                        if (comando.startsWith("CS"))
                                        {
                                            des->cs();
                                            existe_comando = 1;
                                        }

                                        if (comando.startsWith("PD"))
                                        {
                                            des->pd();
                                            existe_comando = 1;
                                        }

                                        if (comando.startsWith("PU"))
                                        {
                                            des->pu();
                                            existe_comando = 1;
                                        }

                                        if (comando.startsWith("HM"))
                                        {
                                            des->hm();
                                            existe_comando = 1;
                                        }

                                        if (comando.startsWith("HT"))
                                        {
                                            des->ht();
                                            existe_comando = 1;
                                        }

                                        if (comando.startsWith("ST"))
                                        {
                                            des->st();
                                            existe_comando = 1;
                                        }

                                        if (comando.startsWith("NEW"))
                                        {
                                            des->cnew();
                                            MensagemTextEdit->setText("");
                                            ComandoTextEdit->setText("");
                                            existe_comando = 1;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        if(existe_comando != -1)
        {
            return prox_comando;
        }
        else
        {
            int pos_tt = comando.find(':',0);

            if(pos_tt != -1)
            {
                parametro_s = (comando.mid(0,pos_tt));
            }
            else
            {
                parametro_s = (comando.mid(0,comando.length()));
            }

            if(find_to(parametro_s) != -1)
            {
                comando_to(comando, parametro_s);
                return prox_comando;
            }
            else
            {
                MensagemTextEdit->append(i18n("Invalid command:"));
                MensagemTextEdit->append(comando);
                tem_erro = 1;
                stop_error();
                return ((ComandoTextEdit->paragraphs())+1);
            }
        }
    }
    else
    {
        return pos_comando + 1;
        ;
    }
}


void KlogoturtleApp::slotRun()
{
    int pos_comando;
    int prox_comando;
    int n_comandos;

    tem_erro = 0;

    saveImage->setEnabled(true);

    n_comandos = ComandoTextEdit->paragraphs();
    pos_comando = 0;

    while (pos_comando < n_comandos)
    {
        prox_comando = Exe_comando(pos_comando);
        pos_comando = prox_comando;
        qual_comando = 1;
    }

    if(tem_erro == 0) des->tartaruga(tem_erro);
}


int KlogoturtleApp::Repete(int param, int par_ini)
{
    int pos_comando;
    int prox_comando;

    for(int h = 1; h <= param; h++)
    {
        pos_comando = par_ini;

        while (pos_comando != -1)
        {
            prox_comando = Exe_comando(pos_comando);
            pos_comando = prox_comando;
        }
    }

    return pos_end_repete;

}


void KlogoturtleApp::stop_error()
{
    des->tartaruga(tem_erro);
}



void KlogoturtleApp::comando_to(QString com_to_name, QString nome)
{
    int pos_comando;
    int prox_comando;
    int n_comandos;
    int pos = find_to(nome);

    QString comand_to_all = guarda_to [pos] [1];

    int teste_arg = com_to_name.contains(':',false);

    temp_comando_to = comand_to_all;

    if(teste_arg > 0)
    {
        if(teste_arg == comand_to_all.contains(':',false))
        {
            for(int w = 1; w <= teste_arg; w++)
            {
                QString valor_para_temp = com_to_name.section(':', w, w);
                QString nome_para_temp = (comand_to_all.section('#', 0, 0)).section(':', w, w);
                temp_comando_to.replace(nome_para_temp,valor_para_temp);
            }

            qual_comando = 0;
            n_comandos = comand_to_all.contains('#',false) - 2;
            pos_comando = 1;

            while (pos_comando <= n_comandos)
            {
                prox_comando = Exe_comando(pos_comando);
                pos_comando = prox_comando;
            }

        }

        qual_comando = 1;

    }
    else
    {
        qual_comando = 0;
        n_comandos = comand_to_all.contains('#',false) - 2;
        pos_comando = 1;

        while (pos_comando <= n_comandos)
        {
            prox_comando = Exe_comando(pos_comando);
            pos_comando = prox_comando;
        }

        qual_comando = 1;
    }
}


void KlogoturtleApp::apaga_to()
{
    for(int h = 0; h < 10; h++)
    {
        for(int g = 0; g < 2; g++)
        {
            guarda_to [h] [g] = "0";
        }
    }
}

void KlogoturtleApp::slotEnableActions()
{
    actionCollection()->action("file_save")->setEnabled(true);
    actionCollection()->action("file_save_as")->setEnabled(true);
    actionCollection()->action("save_image")->setEnabled(true);
    actionCollection()->action("file_print")->setEnabled(true);
    actionCollection()->action("edit_cut")->setEnabled(true);
    actionCollection()->action("edit_copy")->setEnabled(true);
    actionCollection()->action("edit_paste")->setEnabled(true);
}

int KlogoturtleApp::find_to(QString to_name)
{
    int volta = -1;

    for(int l = 0; l < 10; l++)
    {
        if(guarda_to [l] [0] == to_name)
        {
            volta = l;
            break;
        }

    }
    return volta;

}
