/***************************************************************************
                          klogoturtle.h  -  description
                             -------------------
    begin                : Sb Nov  1 18:43:53 BRT 2003
    copyright            : (C) 2003 by Euclides Lourenco Chuma
    email                : euclideschuma@yahoo.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KLOGOTURTLE_H
#define KLOGOTURTLE_H


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt

// include files for KDE
#include <kapplication.h>
#include <kmainwindow.h>
#include <kurl.h>
//#include <kpopupmenu.h>
#include <ktextedit.h>
#include <kglobal.h>
#include <kpushbutton.h>
#include <qlabel.h>
#include <qstring.h>
#include <qfiledialog.h>
#include <qfile.h>
#include <qpaintdevicemetrics.h>
#include <qtextstream.h>

#include "desenho.h"

class KToggleAction;

/**
  * The base class for Klogoturtle application windows. It sets up the main
  * window and reads the config file as well as providing a menubar, toolbar
  * and statusbar. An instance of KlogoturtleView creates your center view, which is connected
  * to the window's Doc object.
  * KlogoturtleApp reimplements the methods that KMainWindow provides for main window handling and supports
  * full session management as well as using KActions.
  * @see KMainWindow
  * @see KApplication
  * @see KConfig
  *
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
  * @version KDevelop version 1.2 code generation
  */
class KlogoturtleApp : public KMainWindow
{
  Q_OBJECT

  public:
    /** construtor of KlogoturtleApp, calls all init functions to create the application.
     */
    KlogoturtleApp(QWidget* parent=0, const char* name=0);
    ~KlogoturtleApp();


    /** returns a pointer to the current document connected to the KTMainWindow instance and is used by
     * the View class to access the document object's methods
     */

    KAction *saveImage;
    KToggleAction *englishAction;
    KToggleAction *portugueseAction;
    KToggleAction *germanAction;
    KToggleAction *italianAction;
    KToggleAction *frenchAction;
    KTextEdit *ComandoTextEdit;
    KTextEdit *MensagemTextEdit;
    KPushButton *runButton;
    QLabel *label1;
    QLabel *label2;
    QLabel *label3;

    int Repete(int param, int par_ini);
    int Exe_comando(int pos_comando);
    int pos_end_repete;
    int find_to(QString to_name);
    int n_to;
    int qual_comando;

    void comando_to(QString comando, QString nome);
    void stop_error();
    void apaga_to();


  protected:
    /** save general Options like all bar positions and status as well as the geometry and the recent file list to the configuration
     * file
     */
    void saveOptions();
    /** read general Options again and initialize all variables like the recent file list
     */
    void readOptions();
    /** initializes the KActions of the application */
    void initActions();
    /** creates the centerwidget of the KTMainWindow instance and sets it as the view
     */
    void initView();

    /** queryExit is called by KTMainWindow when the last window of the application is going to be closed during the closeEvent().
     * Against the default implementation that just returns true, this calls saveOptions() to save the settings of the last window's
     * properties.
     * @see KTMainWindow#queryExit
     * @see KTMainWindow#closeEvent
     */
    virtual bool queryExit();

  private slots:
    ///In Settings menu, Configure Shortcuts... menu item
    void optionsConfigureKeys();

  public slots:
    /** clears the document in the actual view to reuse it as the new document */
    void slotFileNew();
    /** open a file and load it into the document*/
    void slotFileOpen();
    /** save a document */
    void slotFileSave();
    /** save a document by a new filename*/
    void slotFileSaveAs();

    /** print the actual file */
    void slotFilePrint();
    /** closes all open windows by calling close() on each memberList item until the list is empty, then quits the application.
     * If queryClose() returns false because the user canceled the saveModified() dialog, the closing breaks.
     */
    void slotFileQuit();
    /** changes the statusbar contents for the standard label permanently, used to indicate current actions.
     * @param text the text that is displayed in the statusbar
     */
    void slotStatusMsg(const QString &text, int);

    void slotSaveImage();

    void slotIngles();

    void slotAlemao();

    void slotPortugues();

    void slotItaliano();

    void slotFrances();

    void slotRun();

    void slotEnableActions();

  private:
    /** the configuration object of the application */
    KConfig *config;

    Desenho *des;

    QString filename;
    QPrinter *printer;
    QString guarda_to [10] [2];
    QString temp_comando_to;
    QString idioma_escolhido;

    int id_ingles;
    int id_alemao;
    int id_portugues;
    int id__italiano;
    int id__frances;
    int tem_erro;
};

#endif // KLOGOTURTLE_H
